<template>
  <v-infinite-scroll
    :items="items"
    class="overflow-hidden"
    @load="loadMore"
  >
    <template #default>
      <v-data-table
        v-if="!mobile"
        :headers="headerItems"
        :items="items"
        :search="search"
        :items-per-page="itemsPerPage"
        :page="dataTablePage"
        :loading="loading"
        :show-select="showSelect"
        item-value="id"
      >
        <template #headers="{ columns, isSorted, getSortIcon, toggleSort }">
          <tr>
            <template v-for="column in headerItems" :key="column.key">
              <td
                class="px-4 py-3 text-xs text-dark-grey text-medium bg-very-light-grey !border-b border-grey-200 select-none"
                @click="column?.sortable ? toggleSort(column) : null"
              >
                <svn-header-cell
                  :prepend-icon="column?.icon"
                  :sortable="column?.sortable"
                  :text="column?.title"
                  :info="column?.info"
                />
              </td>
            </template>
          </tr>
        </template>

        <template #loading>
          <slot name="loading" />
        </template>

        <template #loader>
          <slot name="loader" />
        </template>

        <template #item="{ item }">
          <slot name="item" :item="item" />
        </template>

        <template #no-data>
          <slot name="no-data" />
        </template>
        
        <template #bottom>
          <slot name="bottom">
            <svn-pagination
              :page="currentPage"
              :length="paginationTotalPages"
              @update:model-value="updatePagination"
            />
          </slot>
        </template>
      </v-data-table>

      <slot v-else name="mobile" />
    </template>

    <template #empty />

    <template #loading />

    <template #load-more />
  </v-infinite-scroll>
</template>

<script setup>
import { ref, watch, onMounted, onUnmounted } from "vue";
import SvnPagination from "@/components/pagination/SvnPagination.vue";
import SvnHeaderCell from "@/components/table_cell/SvnHeaderCell.vue";

const props = defineProps({
  page: { type: Number, default: 1 },
  dataTablePage: { type: Number, default: 1 },
  paginationTotalPages: { type: Number, default: 1 },
  headerItems: { type: Array, default: () => [] },
  items: { type: Array, default: () => [] },
  showSelect: { type: Boolean, default: false },
  itemsPerPage: { type: Number, default: -1 },
  loading: { type: Boolean, default: false },
  mobile: { type: Boolean, default: false },
  search: { type: String, default: '' },
})

const emit = defineEmits(['update-pagination', 'load-more']);

onMounted(() => {
  isMdScreen.value = window.innerWidth > 768;
  window.addEventListener("resize", handleWindowResize);
});

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize);
});

const handleWindowResize = (e) => {
  isMdScreen.value = e.target.innerWidth > 768;
};

const isMdScreen = ref(false);
const currentPage = ref(props?.page);

const updatePagination = (page) => {
  emit('update-pagination', page)
}

watch(props, (newValue, oldValue) => {
  if (newValue.page) {
    currentPage.value = newValue.page
  }
})

const loadMore = async ({ done }) => {
  emit('load-more', { done })
}
</script>

<style scoped>

</style>